## ats2-lang 0.2.6

=== src/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######

CC=gcc
export ATSCCOMP=$(CC)

######

ATSCC=$(ATSHOME)/bin/atscc
ATSOPT=$(ATSHOME)/bin/atsopt

######

CFLAGS=-g
CFLAGS=-g -O
CFLAGS=-g -O2

######
#
GCFLAG=
#
# GCFLAG=-D_ATS_NGC
# GCFLAG=-D_ATS_GCBDW
# GCFLAG=-D_ATS_GCATS
#
######
#
# Bootstrapping:
#
# [gmpknd] for CBOOT
# [intknd] for CBOOTmin
#
C3NSTRINTKND=gmpknd
#C3NSTRINTKND=intknd
#
######

DATSCC=-DATS C3NSTRINTKND=$(C3NSTRINTKND)

######

LIBATS=-lats

######
#
# HX: no [gmp] 
ifeq ($(C3NSTRINTKND),intknd)
LIBGMP=
endif
#
# HX: [gmp] needed
ifeq ($(C3NSTRINTKND),gmpknd)
LIBGMP=-lgmp
endif
#
######

SOURCES := \
  pats_params.hats \
  pats_error.sats \
  pats_error.dats \
  pats_intinf.sats \
  pats_intinf.dats \
  pats_intinf_int.hats \
  pats_intinf_gmp.hats \
  pats_counter.sats \
  pats_counter.dats \
  pats_utils.sats \
  pats_utils.dats \
  pats_global.sats \
  pats_global.dats \
  pats_basics.sats \
  pats_basics.dats \
  pats_basics.hats \
  pats_comarg.sats \
  pats_comarg.dats \
  pats_stamp.sats \
  pats_stamp.dats \
  pats_symbol.sats \
  pats_symbol.dats \
  pats_filename.sats \
  pats_filename.dats \
  pats_filename_reloc.dats \
  pats_location.sats \
  pats_location.dats \
  pats_location.cats \
  pats_jsonize.sats \
  pats_jsonize.dats \
  pats_errmsg.sats \
  pats_errmsg.dats \
  pats_reader.sats \
  pats_reader.dats \
  pats_reader.cats \
  pats_lexbuf.sats \
  pats_lexbuf.dats \
  pats_lexbuf.cats \
  pats_lexing.sats \
  pats_lexing.dats \
  pats_lexing.cats \
  pats_lexing_print.dats \
  pats_lexing_error.dats \
  pats_lexing_token.dats \
  pats_label.sats \
  pats_label.dats \
  pats_effect.sats \
  pats_effect.dats \
  pats_fixity.sats \
  pats_fixity_prec.dats \
  pats_fixity_fxty.dats \
  pats_syntax.sats \
  pats_syntax.dats \
  pats_syntax_print.dats \
  pats_depgen.sats \
  pats_depgen.dats \
  pats_taggen.sats \
  pats_taggen.dats \
  pats_tokbuf.sats \
  pats_tokbuf.dats \
  pats_tokbuf.cats \
  pats_parsing.sats \
  pats_parsing.dats \
  pats_parsing_error.dats \
  pats_parsing_util.dats \
  pats_parsing_kwds.dats \
  pats_parsing_base.dats \
  pats_parsing_e0xp.dats \
  pats_parsing_sort.dats \
  pats_parsing_staexp.dats \
  pats_parsing_p0at.dats \
  pats_parsing_dynexp.dats \
  pats_parsing_decl.dats \
  pats_parsing_toplevel.dats \
  pats_symmap.sats \
  pats_symmap.dats \
  pats_symmap_avltree.hats \
  pats_symmap_htlinprb.hats \
  pats_symenv.sats \
  pats_symenv.dats \
  pats_staexp1.sats \
  pats_staexp1.dats \
  pats_staexp1_print.dats \
  pats_dynexp1.sats \
  pats_dynexp1.dats \
  pats_dynexp1_print.dats \
  pats_trans1.sats \
  pats_trans1_env.sats \
  pats_trans1_env.dats \
  pats_e1xpval.sats \
  pats_e1xpval.dats \
  pats_e1xpval_error.dats \
  pats_trans1_error.dats \
  pats_trans1_e0xp.dats \
  pats_trans1_effect.dats \
  pats_trans1_sort.dats \
  pats_trans1_staexp.dats \
  pats_trans1_p0at.dats \
  pats_trans1_syndef.dats \
  pats_trans1_dynexp.dats \
  pats_trans1_decl.dats \
  pats_staexp2.sats \
  pats_staexp2.dats \
  pats_stacst2.sats \
  pats_stacst2.dats \
  pats_staexp2_print.dats \
  pats_staexp2_pprint.dats \
  pats_staexp2_sort.dats \
  pats_staexp2_scst.dats \
  pats_staexp2_svar.dats \
  pats_staexp2_svvar.dats \
  pats_staexp2_hole.dats \
  pats_staexp2_ctxt.dats \
  pats_staexp2_dcon.dats \
  pats_staexp2_skexp.dats \
  pats_staexp2_szexp.dats \
  pats_staexp2_util.sats \
  pats_staexp2_util1.dats \
  pats_staexp2_util2.dats \
  pats_staexp2_util3.dats \
  pats_staexp2_error.sats \
  pats_staexp2_error.dats \
  pats_staexp2_solve.sats \
  pats_staexp2_solve.dats \
  pats_patcst2.sats \
  pats_patcst2.dats \
  pats_dynexp2.sats \
  pats_dynexp2.dats \
  pats_dyncst2.sats \
  pats_dyncst2.dats \
  pats_dynexp2_print.dats \
  pats_dynexp2_dcst.dats \
  pats_dynexp2_dvar.dats \
  pats_dynexp2_dmac.dats \
  pats_dynexp2_util.dats \
  pats_staexp2_appenv.hats \
  pats_dynexp2_appenv.hats \
  pats_dynexp2_mapgen.dats \
  pats_trans2.sats \
  pats_namespace.sats \
  pats_namespace.dats \
  pats_trans2_env.sats \
  pats_trans2_env.dats \
  pats_trans2_error.dats \
  pats_trans2_sort.dats \
  pats_trans2_staexp.dats \
  pats_trans2_p1at.dats \
  pats_trans2_dynexp.dats \
  pats_trans2_impdec.dats \
  pats_trans2_decl.dats \
  pats_codegen2.sats \
  pats_codegen2.dats \
  pats_codegen2_util.dats \
  pats_codegen2_datype.dats \
  pats_codegen2_fprint.dats \
  pats_jsonize_synent2.sats \
  pats_jsonize_synent2.dats \
  pats_dynexp3.sats \
  pats_dynexp3.dats \
  pats_dynexp3_print.dats \
  pats_trans3.sats \
  pats_trans3_error.dats \
  pats_trans3_util.dats \
  pats_trans3_env.sats \
  pats_trans3_env.dats \
  pats_trans3_env_print.dats \
  pats_trans3_env_scst.dats \
  pats_trans3_env_svar.dats \
  pats_trans3_env_termet.dats \
  pats_trans3_env_effect.dats \
  pats_trans3_env_dvar.dats \
  pats_trans3_env_lamlp.dats \
  pats_trans3_env_pfman.dats \
  pats_trans3_env_lstate.dats \
  pats_dmacro2.sats \
  pats_dmacro2.dats \
  pats_dmacro2_print.dats \
  pats_dmacro2_eval0.dats \
  pats_dmacro2_eval1.dats \
  pats_trans3_p2at.dats \
  pats_trans3_patcon.dats \
  pats_trans3_syncst.dats \
  pats_trans3_dynexp_up.dats \
  pats_trans3_dynexp_dn.dats \
  pats_trans3_appsym.dats \
  pats_trans3_caseof.dats \
  pats_trans3_selab.dats \
  pats_trans3_ptrof.dats \
  pats_trans3_viewat.dats \
  pats_trans3_deref.dats \
  pats_trans3_assgn.dats \
  pats_trans3_xchng.dats \
  pats_trans3_lvalres.dats \
  pats_trans3_fldfrat.dats \
  pats_trans3_looping.dats \
  pats_trans3_decl.dats \
  pats_lintprgm.sats \
  pats_lintprgm.dats \
  pats_lintprgm_print.dats \
  pats_lintprgm_myint.cats \
  pats_lintprgm_myint.dats \
  pats_lintprgm_solve.dats \
  pats_constraint3.sats \
  pats_constraint3.dats \
  pats_constraint3_print.dats \
  pats_constraint3_appenv.hats \
  pats_constraint3_mapgen.dats \
  pats_constraint3_jsonize.dats \
  pats_constraint3_init.dats \
  pats_constraint3_simplify.dats \
  pats_constraint3_icnstr.dats \
  pats_constraint3_solve.dats \
  pats_histaexp.sats \
  pats_histaexp.dats \
  pats_histaexp_print.dats \
  pats_histaexp_funlab.dats \
  pats_hidynexp.sats \
  pats_hidynexp.dats \
  pats_hidynexp_print.dats \
  pats_hidynexp_util.dats \
  pats_typerase.sats \
  pats_typerase_error.dats \
  pats_typerase_staexp.dats \
  pats_typerase_dynexp.dats \
  pats_typerase_decl.dats \
  pats_ccomp.sats \
  pats_ccomp.dats \
  pats_ccomp_print.dats \
  pats_ccomp_hitype.dats \
  pats_ccomp_tmplab.dats \
  pats_ccomp_tmpvar.dats \
  pats_ccomp_d2env.dats \
  pats_ccomp_funlab.dats \
  pats_ccomp_funent.dats \
  pats_ccomp_util.dats \
  pats_ccomp_ccompenv.dats \
  pats_ccomp_instrseq.dats \
  pats_ccomp_hipat.dats \
  pats_ccomp_dynexp.dats \
  pats_ccomp_caseof.dats \
  pats_ccomp_claulst.dats \
  pats_ccomp_lazyeval.dats \
  pats_ccomp_trywith.dats \
  pats_ccomp_looping.dats \
  pats_ccomp_decl.dats \
  pats_ccomp_subst.dats \
  pats_ccomp_environ.dats \
  pats_ccomp_template.dats \
  pats_ccomp_emit.dats \
  pats_ccomp_emit2.dats \
  pats_ccomp_emit3.dats \
  pats_ccomp_main.dats \


SOURCESsta := $(filter %.sats, $(SOURCES))
SOURCESdyn := $(filter %.dats, $(SOURCES))

######

OBJECTS := \
  pats_error_sats.o \
  pats_error_dats.o \
  pats_intinf_sats.o \
  pats_intinf_dats.o \
  pats_counter_sats.o \
  pats_counter_dats.o \
  pats_utils_sats.o \
  pats_utils_dats.o \
  pats_global_sats.o \
  pats_global_dats.o \
  pats_basics_sats.o \
  pats_basics_dats.o \
  pats_comarg_sats.o \
  pats_comarg_dats.o \
  pats_stamp_sats.o \
  pats_stamp_dats.o \
  pats_symbol_sats.o \
  pats_symbol_dats.o \
  pats_filename_sats.o \
  pats_filename_dats.o \
  pats_filename_reloc_dats.o \
  pats_location_sats.o \
  pats_location_dats.o \
  pats_jsonize_sats.o \
  pats_jsonize_dats.o \
  pats_errmsg_sats.o \
  pats_errmsg_dats.o \
  pats_reader_sats.o \
  pats_reader_dats.o \
  pats_lexbuf_sats.o \
  pats_lexbuf_dats.o \
  pats_lexing_sats.o \
  pats_lexing_dats.o \
  pats_lexing_print_dats.o \
  pats_lexing_error_dats.o \
  pats_lexing_token_dats.o \
  pats_label_sats.o \
  pats_label_dats.o \
  pats_effect_sats.o \
  pats_effect_dats.o \
  pats_fixity_sats.o \
  pats_fixity_prec_dats.o \
  pats_fixity_fxty_dats.o \
  pats_syntax_sats.o \
  pats_syntax_dats.o \
  pats_syntax_print_dats.o \
  pats_depgen_sats.o \
  pats_depgen_dats.o \
  pats_taggen_sats.o \
  pats_taggen_dats.o \
  pats_tokbuf_sats.o \
  pats_tokbuf_dats.o \
  pats_parsing_sats.o \
  pats_parsing_dats.o \
  pats_parsing_error_dats.o \
  pats_parsing_util_dats.o \
  pats_parsing_kwds_dats.o \
  pats_parsing_base_dats.o \
  pats_parsing_e0xp_dats.o \
  pats_parsing_sort_dats.o \
  pats_parsing_staexp_dats.o \
  pats_parsing_p0at_dats.o \
  pats_parsing_dynexp_dats.o \
  pats_parsing_decl_dats.o \
  pats_parsing_toplevel_dats.o \
  pats_symmap_sats.o \
  pats_symmap_dats.o \
  pats_symenv_sats.o \
  pats_symenv_dats.o \
  pats_staexp1_sats.o \
  pats_staexp1_dats.o \
  pats_staexp1_print_dats.o \
  pats_dynexp1_sats.o \
  pats_dynexp1_dats.o \
  pats_dynexp1_print_dats.o \
  pats_trans1_sats.o \
  pats_trans1_env_sats.o \
  pats_trans1_env_dats.o \
  pats_e1xpval_sats.o \
  pats_e1xpval_dats.o \
  pats_e1xpval_error_dats.o \
  pats_trans1_error_dats.o \
  pats_trans1_e0xp_dats.o \
  pats_trans1_effect_dats.o \
  pats_trans1_sort_dats.o \
  pats_trans1_staexp_dats.o \
  pats_trans1_p0at_dats.o \
  pats_trans1_syndef_dats.o \
  pats_trans1_dynexp_dats.o \
  pats_trans1_decl_dats.o \
  pats_staexp2_sats.o \
  pats_staexp2_dats.o \
  pats_stacst2_sats.o \
  pats_stacst2_dats.o \
  pats_staexp2_print_dats.o \
  pats_staexp2_pprint_dats.o \
  pats_staexp2_sort_dats.o \
  pats_staexp2_scst_dats.o \
  pats_staexp2_svar_dats.o \
  pats_staexp2_svvar_dats.o \
  pats_staexp2_hole_dats.o \
  pats_staexp2_ctxt_dats.o \
  pats_staexp2_dcon_dats.o \
  pats_staexp2_skexp_dats.o \
  pats_staexp2_szexp_dats.o \
  pats_staexp2_util_sats.o \
  pats_staexp2_util1_dats.o \
  pats_staexp2_util2_dats.o \
  pats_staexp2_util3_dats.o \
  pats_staexp2_error_sats.o \
  pats_staexp2_error_dats.o \
  pats_staexp2_solve_sats.o \
  pats_staexp2_solve_dats.o \
  pats_patcst2_sats.o \
  pats_patcst2_dats.o \
  pats_dynexp2_sats.o \
  pats_dynexp2_dats.o \
  pats_dyncst2_sats.o \
  pats_dyncst2_dats.o \
  pats_dynexp2_print_dats.o \
  pats_dynexp2_dcst_dats.o \
  pats_dynexp2_dvar_dats.o \
  pats_dynexp2_dmac_dats.o \
  pats_dynexp2_util_dats.o \
  pats_dynexp2_mapgen_dats.o \
  pats_trans2_sats.o \
  pats_namespace_sats.o \
  pats_namespace_dats.o \
  pats_trans2_env_sats.o \
  pats_trans2_env_dats.o \
  pats_trans2_error_dats.o \
  pats_trans2_sort_dats.o \
  pats_trans2_staexp_dats.o \
  pats_trans2_p1at_dats.o \
  pats_trans2_dynexp_dats.o \
  pats_trans2_impdec_dats.o \
  pats_trans2_decl_dats.o \
  pats_codegen2_sats.o \
  pats_codegen2_dats.o \
  pats_codegen2_util_dats.o \
  pats_codegen2_datype_dats.o \
  pats_codegen2_fprint_dats.o \
  pats_jsonize_synent2_sats.o \
  pats_jsonize_synent2_dats.o \
  pats_dynexp3_sats.o \
  pats_dynexp3_dats.o \
  pats_dynexp3_print_dats.o \
  pats_trans3_sats.o \
  pats_trans3_error_dats.o \
  pats_trans3_util_dats.o \
  pats_trans3_env_sats.o \
  pats_trans3_env_dats.o \
  pats_trans3_env_print_dats.o \
  pats_trans3_env_scst_dats.o \
  pats_trans3_env_svar_dats.o \
  pats_trans3_env_termet_dats.o \
  pats_trans3_env_effect_dats.o \
  pats_trans3_env_dvar_dats.o \
  pats_trans3_env_lamlp_dats.o \
  pats_trans3_env_pfman_dats.o \
  pats_trans3_env_lstate_dats.o \
  pats_dmacro2_sats.o \
  pats_dmacro2_dats.o \
  pats_dmacro2_print_dats.o \
  pats_dmacro2_eval0_dats.o \
  pats_dmacro2_eval1_dats.o \
  pats_trans3_p2at_dats.o \
  pats_trans3_patcon_dats.o \
  pats_trans3_syncst_dats.o \
  pats_trans3_dynexp_up_dats.o \
  pats_trans3_dynexp_dn_dats.o \
  pats_trans3_appsym_dats.o \
  pats_trans3_caseof_dats.o \
  pats_trans3_selab_dats.o \
  pats_trans3_ptrof_dats.o \

=== ccomp/atslib/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######

PATSHOMEQ="$(PATSHOME)"
PATSRUNTIME=$(PATSHOMEQ)/ccomp/runtime

######

PATSOPT=$(PATSHOMEQ)/bin/patsopt

######

CCOMP=gcc
CCFLAGS=-fPIC -O2

######
#
DATSMEMALLOC=
#
# DATSMEMALLOC=-DATS_MEMALLOC_LIBC
# DATSMEMALLOC=-DATS_MEMALLOC_GCBDW
#
######

all:: atslib
all:: ; ranlib lib/libatslib.a

######

atslib:: atslib_prelude

######

atslib_prelude:: atslib_prelude_bool_dats
atslib_prelude_bool_dats: output/atslib_prelude_bool_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_bool_dats.c: ../../prelude/DATS/bool.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_bool_dats.o: output/atslib_prelude_bool_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_bool_dats.c
clean:: ; $(RMF) output/atslib_prelude_bool_dats.o

atslib_prelude:: atslib_prelude_char_dats
atslib_prelude_char_dats: output/atslib_prelude_char_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_char_dats.c: ../../prelude/DATS/char.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_char_dats.o: output/atslib_prelude_char_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_char_dats.c
clean:: ; $(RMF) output/atslib_prelude_char_dats.o

atslib_prelude:: atslib_prelude_integer_dats
atslib_prelude_integer_dats: output/atslib_prelude_integer_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_integer_dats.c: ../../prelude/DATS/integer.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_integer_dats.o: output/atslib_prelude_integer_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_integer_dats.c
clean:: ; $(RMF) output/atslib_prelude_integer_dats.o

atslib_prelude:: atslib_prelude_float_dats
atslib_prelude_float_dats: output/atslib_prelude_float_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_float_dats.c: ../../prelude/DATS/float.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_float_dats.o: output/atslib_prelude_float_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_float_dats.c
clean:: ; $(RMF) output/atslib_prelude_float_dats.o

atslib_prelude:: atslib_prelude_string_dats
atslib_prelude_string_dats: output/atslib_prelude_string_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_string_dats.c: ../../prelude/DATS/string.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_string_dats.o: output/atslib_prelude_string_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_string_dats.c
clean:: ; $(RMF) output/atslib_prelude_string_dats.o

atslib_prelude:: atslib_prelude_strptr_dats
atslib_prelude_strptr_dats: output/atslib_prelude_strptr_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_strptr_dats.c: ../../prelude/DATS/strptr.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_strptr_dats.o: output/atslib_prelude_strptr_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_strptr_dats.c
clean:: ; $(RMF) output/atslib_prelude_strptr_dats.o


######

atslib_prelude:: atslib_prelude_filebas_dats
atslib_prelude_filebas_dats: output/atslib_prelude_filebas_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_prelude_filebas_dats.c: ../../prelude/DATS/filebas.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_prelude_filebas_dats.o: output/atslib_prelude_filebas_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_prelude_filebas_dats.c
clean:: ; $(RMF) output/atslib_prelude_filebas_dats.o


######

atslib:: atslib_libc

######

atslib_libc:: atslib_libc_dirent_dats
atslib_libc_dirent_dats: output/atslib_libc_dirent_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_dirent_dats.c: ../../libc/DATS/dirent.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_dirent_dats.o: output/atslib_libc_dirent_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_dirent_dats.c
clean:: ; $(RMF) output/atslib_libc_dirent_dats.o

atslib_libc:: atslib_libc_fcntl_dats
atslib_libc_fcntl_dats: output/atslib_libc_fcntl_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_fcntl_dats.c: ../../libc/DATS/fcntl.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_fcntl_dats.o: output/atslib_libc_fcntl_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_fcntl_dats.c
clean:: ; $(RMF) output/atslib_libc_fcntl_dats.o

atslib_libc:: atslib_libc_stdio_dats
atslib_libc_stdio_dats: output/atslib_libc_stdio_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_stdio_dats.c: ../../libc/DATS/stdio.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_stdio_dats.o: output/atslib_libc_stdio_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_stdio_dats.c
clean:: ; $(RMF) output/atslib_libc_stdio_dats.o

atslib_libc:: atslib_libc_stdlib_dats
atslib_libc_stdlib_dats: output/atslib_libc_stdlib_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_stdlib_dats.c: ../../libc/DATS/stdlib.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_stdlib_dats.o: output/atslib_libc_stdlib_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_stdlib_dats.c
clean:: ; $(RMF) output/atslib_libc_stdlib_dats.o

atslib_libc:: atslib_libc_string_dats
atslib_libc_string_dats: output/atslib_libc_string_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_string_dats.c: ../../libc/DATS/string.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_string_dats.o: output/atslib_libc_string_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_string_dats.c
clean:: ; $(RMF) output/atslib_libc_string_dats.o

atslib_libc:: atslib_libc_strings_dats
atslib_libc_strings_dats: output/atslib_libc_strings_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_strings_dats.c: ../../libc/DATS/strings.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_strings_dats.o: output/atslib_libc_strings_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_strings_dats.c
clean:: ; $(RMF) output/atslib_libc_strings_dats.o

atslib_libc:: atslib_libc_time_dats
atslib_libc_time_dats: output/atslib_libc_time_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_time_dats.c: ../../libc/DATS/time.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_time_dats.o: output/atslib_libc_time_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_time_dats.c
clean:: ; $(RMF) output/atslib_libc_time_dats.o

atslib_libc:: atslib_libc_unistd_dats
atslib_libc_unistd_dats: output/atslib_libc_unistd_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_unistd_dats.c: ../../libc/DATS/unistd.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_unistd_dats.o: output/atslib_libc_unistd_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_unistd_dats.c
clean:: ; $(RMF) output/atslib_libc_unistd_dats.o


######

atslib:: atslib_libc_sys

######

atslib_libc_sys:: atslib_libc_sys_socket_dats
atslib_libc_sys_socket_dats: output/atslib_libc_sys_socket_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_sys_socket_dats.c: ../../libc/sys/DATS/socket.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_sys_socket_dats.o: output/atslib_libc_sys_socket_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_sys_socket_dats.c
clean:: ; $(RMF) output/atslib_libc_sys_socket_dats.o

atslib_libc_sys:: atslib_libc_sys_socket_in_dats
atslib_libc_sys_socket_in_dats: output/atslib_libc_sys_socket_in_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_sys_socket_in_dats.c: ../../libc/sys/DATS/socket_in.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_sys_socket_in_dats.o: output/atslib_libc_sys_socket_in_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_sys_socket_in_dats.c
clean:: ; $(RMF) output/atslib_libc_sys_socket_in_dats.o

atslib_libc_sys:: atslib_libc_sys_stat_dats
atslib_libc_sys_stat_dats: output/atslib_libc_sys_stat_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_sys_stat_dats.c: ../../libc/sys/DATS/stat.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_sys_stat_dats.o: output/atslib_libc_sys_stat_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_sys_stat_dats.c
clean:: ; $(RMF) output/atslib_libc_sys_stat_dats.o

atslib_libc_sys:: atslib_libc_sys_types_dats
atslib_libc_sys_types_dats: output/atslib_libc_sys_types_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libc_sys_types_dats.c: ../../libc/sys/DATS/types.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libc_sys_types_dats.o: output/atslib_libc_sys_types_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libc_sys_types_dats.c
clean:: ; $(RMF) output/atslib_libc_sys_types_dats.o


######

atslib:: atslib_libats

######

atslib_libats:: atslib_libats_stringbuf_dats
atslib_libats_stringbuf_dats: output/atslib_libats_stringbuf_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libats_stringbuf_dats.c: ../../libats/DATS/stringbuf.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libats_stringbuf_dats.o: output/atslib_libats_stringbuf_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libats_stringbuf_dats.c
clean:: ; $(RMF) output/atslib_libats_stringbuf_dats.o


######

atslib_libats:: atslib_libats_funset_avltree_dats
atslib_libats_funset_avltree_dats: output/atslib_libats_funset_avltree_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libats_funset_avltree_dats.c: ../../libats/DATS/funset_avltree.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libats_funset_avltree_dats.o: output/atslib_libats_funset_avltree_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libats_funset_avltree_dats.c
clean:: ; $(RMF) output/atslib_libats_funset_avltree_dats.o

atslib_libats:: atslib_libats_funset_listord_dats
atslib_libats_funset_listord_dats: output/atslib_libats_funset_listord_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libats_funset_listord_dats.c: ../../libats/DATS/funset_listord.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libats_funset_listord_dats.o: output/atslib_libats_funset_listord_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<
clean:: ; $(RMF) output/atslib_libats_funset_listord_dats.c
clean:: ; $(RMF) output/atslib_libats_funset_listord_dats.o

atslib_libats:: atslib_libats_funmap_list_dats
atslib_libats_funmap_list_dats: output/atslib_libats_funmap_list_dats.o ; $(ARR) lib/libatslib.a $<
output/atslib_libats_funmap_list_dats.c: ../../libats/DATS/funmap_list.dats ; $(PATSOPT) -o $@ --dynamic $<
output/atslib_libats_funmap_list_dats.o: output/atslib_libats_funmap_list_dats.c ; \
  $(CCOMP) -I$(PATSHOMEQ) -I$(PATSRUNTIME) $(DATSMEMALLOC) $(CCFLAGS) -c -o $@ $<

=== doc/EXAMPLE/ATSLIB/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######

CCOPT=gcc -std=c99

######

ifeq ("$(PATSHOME)","")
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="$(PATSHOME)"
endif

######

PATSOPT=$(PATSHOMEQ)/bin/patsopt
PATSLIB=$(PATSHOMEQ)/ccomp/atslib/lib

######

all::

######

LNS=ln -s
RMF=rm -f

######

all:: prelude_basics
prelude_basics: prelude_basics.exe
prelude_basics.exe: prelude_basics_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
prelude_basics_dats.c: prelude_basics.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_basics_dats.c --dynamic prelude_basics.dats
clean:: ; $(RMF) prelude_basics_dats.o
clean:: ; $(RMF) prelude_basics_dats.c
cleanall:: ; $(RMF) prelude_basics.exe


######

all:: prelude_integer
prelude_integer: prelude_integer.exe
prelude_integer.exe: prelude_integer_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_integer_dats.c: prelude_integer.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_integer_dats.c --dynamic prelude_integer.dats
clean:: ; $(RMF) prelude_integer_dats.o
clean:: ; $(RMF) prelude_integer_dats.c
cleanall:: ; $(RMF) prelude_integer.exe


######

all:: prelude_bool
prelude_bool: prelude_bool.exe
prelude_bool.exe: prelude_bool_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_bool_dats.c: prelude_bool.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_bool_dats.c --dynamic prelude_bool.dats
clean:: ; $(RMF) prelude_bool_dats.o
clean:: ; $(RMF) prelude_bool_dats.c
cleanall:: ; $(RMF) prelude_bool.exe

all:: prelude_char
prelude_char: prelude_char.exe
prelude_char.exe: prelude_char_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_char_dats.c: prelude_char.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_char_dats.c --dynamic prelude_char.dats
clean:: ; $(RMF) prelude_char_dats.o
clean:: ; $(RMF) prelude_char_dats.c
cleanall:: ; $(RMF) prelude_char.exe

all:: prelude_float
prelude_float: prelude_float.exe
prelude_float.exe: prelude_float_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -lm
prelude_float_dats.c: prelude_float.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_float_dats.c --dynamic prelude_float.dats
clean:: ; $(RMF) prelude_float_dats.o
clean:: ; $(RMF) prelude_float_dats.c
cleanall:: ; $(RMF) prelude_float.exe


######

all:: prelude_string
prelude_string: prelude_string.exe
prelude_string.exe: prelude_string_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
prelude_string_dats.c: prelude_string.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_string_dats.c --dynamic prelude_string.dats
clean:: ; $(RMF) prelude_string_dats.o
clean:: ; $(RMF) prelude_string_dats.c
cleanall:: ; $(RMF) prelude_string.exe


######

all:: prelude_memory
prelude_memory: prelude_memory.exe
prelude_memory.exe: prelude_memory_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_memory_dats.c: prelude_memory.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_memory_dats.c --dynamic prelude_memory.dats
clean:: ; $(RMF) prelude_memory_dats.o
clean:: ; $(RMF) prelude_memory_dats.c
cleanall:: ; $(RMF) prelude_memory.exe

all:: prelude_pointer
prelude_pointer: prelude_pointer.exe
prelude_pointer.exe: prelude_pointer_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_pointer_dats.c: prelude_pointer.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_pointer_dats.c --dynamic prelude_pointer.dats
clean:: ; $(RMF) prelude_pointer_dats.o
clean:: ; $(RMF) prelude_pointer_dats.c
cleanall:: ; $(RMF) prelude_pointer.exe


######

all:: prelude_reference
prelude_reference: prelude_reference.exe
prelude_reference.exe: prelude_reference_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_reference_dats.c: prelude_reference.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_reference_dats.c --dynamic prelude_reference.dats
clean:: ; $(RMF) prelude_reference_dats.o
clean:: ; $(RMF) prelude_reference_dats.c
cleanall:: ; $(RMF) prelude_reference.exe


######

all:: prelude_filebas
prelude_filebas: prelude_filebas.exe
prelude_filebas.exe: prelude_filebas_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
prelude_filebas_dats.c: prelude_filebas.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_filebas_dats.c --dynamic prelude_filebas.dats
clean:: ; $(RMF) prelude_filebas_dats.o
clean:: ; $(RMF) prelude_filebas_dats.c
cleanall:: ; $(RMF) prelude_filebas.exe


######

all:: prelude_intrange
prelude_intrange: prelude_intrange.exe
prelude_intrange.exe: prelude_intrange_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
prelude_intrange_dats.c: prelude_intrange.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_intrange_dats.c --dynamic prelude_intrange.dats
clean:: ; $(RMF) prelude_intrange_dats.o
clean:: ; $(RMF) prelude_intrange_dats.c
cleanall:: ; $(RMF) prelude_intrange.exe


######

all:: prelude_checkast
prelude_checkast: prelude_checkast.exe
prelude_checkast.exe: prelude_checkast_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
prelude_checkast_dats.c: prelude_checkast.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_checkast_dats.c --dynamic prelude_checkast.dats
clean:: ; $(RMF) prelude_checkast_dats.o
clean:: ; $(RMF) prelude_checkast_dats.c
cleanall:: ; $(RMF) prelude_checkast.exe


######

all:: prelude_list
prelude_list: prelude_list.exe
prelude_list.exe: prelude_list_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_list_dats.c: prelude_list.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_list_dats.c --dynamic prelude_list.dats
clean:: ; $(RMF) prelude_list_dats.o
clean:: ; $(RMF) prelude_list_dats.c
cleanall:: ; $(RMF) prelude_list.exe

all:: prelude_list_vt
prelude_list_vt: prelude_list_vt.exe
prelude_list_vt.exe: prelude_list_vt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_list_vt_dats.c: prelude_list_vt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_list_vt_dats.c --dynamic prelude_list_vt.dats
clean:: ; $(RMF) prelude_list_vt_dats.o
clean:: ; $(RMF) prelude_list_vt_dats.c
cleanall:: ; $(RMF) prelude_list_vt.exe


all:: prelude_option
prelude_option: prelude_option.exe
prelude_option.exe: prelude_option_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_option_dats.c: prelude_option.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_option_dats.c --dynamic prelude_option.dats
clean:: ; $(RMF) prelude_option_dats.o
clean:: ; $(RMF) prelude_option_dats.c
cleanall:: ; $(RMF) prelude_option.exe

all:: prelude_option_vt
prelude_option_vt: prelude_option_vt.exe
prelude_option_vt.exe: prelude_option_vt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_option_vt_dats.c: prelude_option_vt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_option_vt_dats.c --dynamic prelude_option_vt.dats
clean:: ; $(RMF) prelude_option_vt_dats.o
clean:: ; $(RMF) prelude_option_vt_dats.c
cleanall:: ; $(RMF) prelude_option_vt.exe


all:: prelude_array
prelude_array: prelude_array.exe
prelude_array.exe: prelude_array_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_array_dats.c: prelude_array.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_array_dats.c --dynamic prelude_array.dats
clean:: ; $(RMF) prelude_array_dats.o
clean:: ; $(RMF) prelude_array_dats.c
cleanall:: ; $(RMF) prelude_array.exe

all:: prelude_arrayptr
prelude_arrayptr: prelude_arrayptr.exe
prelude_arrayptr.exe: prelude_arrayptr_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_arrayptr_dats.c: prelude_arrayptr.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_arrayptr_dats.c --dynamic prelude_arrayptr.dats
clean:: ; $(RMF) prelude_arrayptr_dats.o
clean:: ; $(RMF) prelude_arrayptr_dats.c
cleanall:: ; $(RMF) prelude_arrayptr.exe

all:: prelude_arrayref
prelude_arrayref: prelude_arrayref.exe
prelude_arrayref.exe: prelude_arrayref_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_arrayref_dats.c: prelude_arrayref.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_arrayref_dats.c --dynamic prelude_arrayref.dats
clean:: ; $(RMF) prelude_arrayref_dats.o
clean:: ; $(RMF) prelude_arrayref_dats.c
cleanall:: ; $(RMF) prelude_arrayref.exe


all:: prelude_matrix
prelude_matrix: prelude_matrix.exe
prelude_matrix.exe: prelude_matrix_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_matrix_dats.c: prelude_matrix.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_matrix_dats.c --dynamic prelude_matrix.dats
clean:: ; $(RMF) prelude_matrix_dats.o
clean:: ; $(RMF) prelude_matrix_dats.c
cleanall:: ; $(RMF) prelude_matrix.exe

all:: prelude_matrixptr
prelude_matrixptr: prelude_matrixptr.exe
prelude_matrixptr.exe: prelude_matrixptr_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_matrixptr_dats.c: prelude_matrixptr.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_matrixptr_dats.c --dynamic prelude_matrixptr.dats
clean:: ; $(RMF) prelude_matrixptr_dats.o
clean:: ; $(RMF) prelude_matrixptr_dats.c
cleanall:: ; $(RMF) prelude_matrixptr.exe

all:: prelude_matrixref
prelude_matrixref: prelude_matrixref.exe
prelude_matrixref.exe: prelude_matrixref_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_matrixref_dats.c: prelude_matrixref.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_matrixref_dats.c --dynamic prelude_matrixref.dats
clean:: ; $(RMF) prelude_matrixref_dats.o
clean:: ; $(RMF) prelude_matrixref_dats.c
cleanall:: ; $(RMF) prelude_matrixref.exe


all:: prelude_stream
prelude_stream: prelude_stream.exe
prelude_stream.exe: prelude_stream_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_stream_dats.c: prelude_stream.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_stream_dats.c --dynamic prelude_stream.dats
clean:: ; $(RMF) prelude_stream_dats.o
clean:: ; $(RMF) prelude_stream_dats.c
cleanall:: ; $(RMF) prelude_stream.exe

all:: prelude_stream_vt
prelude_stream_vt: prelude_stream_vt.exe
prelude_stream_vt.exe: prelude_stream_vt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_stream_vt_dats.c: prelude_stream_vt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_stream_vt_dats.c --dynamic prelude_stream_vt.dats
clean:: ; $(RMF) prelude_stream_vt_dats.o
clean:: ; $(RMF) prelude_stream_vt_dats.c
cleanall:: ; $(RMF) prelude_stream_vt.exe


######

all:: prelude_grandom

=== doc/EXAMPLE/INTRO/Makefile ===
#
# A simple Makefile
# for testing doc/EXAMPLE/INTRO
#

######

CCOMP=gcc

######

include $(PATSHOME)/share/atsmake-pre.mk

######

MYTARGET=MYTARGET
MYCCRULE=MYCCRULE

######

include $(PATSHOME)/share/atsmake-post.mk

######

PATSCCOMP=\
$(CCOMP) -D_XOPEN_SOURCE -I${PATSHOMEQ} -I${PATSHOMEQ}/ccomp/runtime

######

export PATSCCOMP

######

all:: acker1
all:: acker2
all:: acker3
all:: acker4
all:: areverse
all:: atof
all:: atoi
all:: bintree
all:: f91
all:: fact1
all:: fact2
all:: fact3
all:: fact_uninterp
all:: fcopy
all:: fcopy2
all:: fib1
all:: fib2
all:: fibmem
all:: fib_lazy
all:: fib_llazy
all:: fprintlst2
all:: fprtuple
all:: gfact
all:: hello
all:: intecho
all:: intrange
all:: linenmbr
all:: listfuns
all:: listpermute
all:: ordset
all:: sieve_lazy
all:: sieve_llazy
all:: staref
all:: strprefix
all:: tally

######

regress:: acker1 ; ./acker1
regress:: acker2 ; ./acker2
regress:: acker3 ; ./acker3
regress:: acker4 ; ./acker4
regress:: areverse ; ./areverse
regress:: atof ; ./atof
regress:: atoi ; ./atoi
regress:: bintree ; ./bintree
regress:: f91 ; ./f91
regress:: fact1 ; ./fact1 10
regress:: fact2 ; ./fact2
regress:: fact3 ; ./fact3
regress:: fact_uninterp ; ./fact_uninterp
#regress:: fcopy ; ./fcopy
#regress:: fcopy2 ; ./fcopy2
regress:: fib1 ; ./fib1
regress:: fib2 ; ./fib2
regress:: fibmem ; ./fibmem
regress:: fib_lazy ; ./fib_lazy
regress:: fib_llazy ; ./fib_llazy
regress:: fprintlst2 ; ./fprintlst2
regress:: fprtuple ; ./fprtuple
regress:: gfact ; ./gfact
regress:: hello ; ./hello
#regress:: intecho ; ./intecho
regress:: intrange ; ./intrange
#regress:: linenmbr ; ./linenmbr
regress:: listfuns ; ./listfuns
regress:: listpermute ; ./listpermute
regress:: ordset ; ./ordset
regress:: sieve_lazy ; ./sieve_lazy
regress:: sieve_llazy ; ./sieve_llazy
regress:: staref ; ./staref
regress:: strprefix ; ./strprefix
regress:: tally ; ./tally

######

cleanall:: ; $(RMF) acker1
cleanall:: ; $(RMF) acker2
cleanall:: ; $(RMF) acker3
cleanall:: ; $(RMF) acker4
cleanall:: ; $(RMF) areverse
cleanall:: ; $(RMF) atof
cleanall:: ; $(RMF) atoi
cleanall:: ; $(RMF) bintree
cleanall:: ; $(RMF) f91
cleanall:: ; $(RMF) fact1
cleanall:: ; $(RMF) fact2
cleanall:: ; $(RMF) fact3
cleanall:: ; $(RMF) fact_uninterp
cleanall:: ; $(RMF) fcopy
cleanall:: ; $(RMF) fcopy2
cleanall:: ; $(RMF) fib1
cleanall:: ; $(RMF) fib2
cleanall:: ; $(RMF) fibmem
cleanall:: ; $(RMF) fib_lazy
cleanall:: ; $(RMF) fib_llazy
cleanall:: ; $(RMF) fprintlst2
cleanall:: ; $(RMF) fprtuple
cleanall:: ; $(RMF) gfact
cleanall:: ; $(RMF) hello
cleanall:: ; $(RMF) intecho
cleanall:: ; $(RMF) intrange
cleanall:: ; $(RMF) linenmbr
cleanall:: ; $(RMF) listfuns
cleanall:: ; $(RMF) listpermute
cleanall:: ; $(RMF) ordset
cleanall:: ; $(RMF) sieve_lazy
cleanall:: ; $(RMF) sieve_llazy
cleanall:: ; $(RMF) staref
cleanall:: ; $(RMF) strprefix
cleanall:: ; $(RMF) tally

######

testall:: all
testall:: regress
testall:: cleanall

######

acker1: acker1.dats ; $(PATSCC) -o $@ $<
acker2: acker2.dats ; $(PATSCC) -o $@ $<
acker3: acker3.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<
acker4: acker4.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

areverse: areverse.dats ; \
  $(PATSCC) -D_ATS_EXCEPTION_NONE -DATS_MEMALLOC_LIBC -o $@ $<

######

atof: acker1.dats ; $(PATSCC) -o $@ $<
atoi: acker1.dats ; $(PATSCC) -o $@ $<

######

bintree: bintree.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

f91: f91.dats ; $(PATSCC) -o $@ $<

######
#
fact1: fact1.dats ; $(PATSCC) -o $@ $<
fact2: fact2.dats ; $(PATSCC) -o $@ $<
fact3: fact3.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<
#
fact_uninterp: fact_uninterp.dats ; $(PATSCC) -o $@ $<
#
######

fcopy: fcopy.dats ; $(PATSCC) -o $@ $<
fcopy2: fcopy2.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $< myatslib.dats 

######

fib1: fib1.dats ; $(PATSCC) -o $@ $<
fib2: fib2.dats ; $(PATSCC) -o $@ $<
fibmem: fibmem.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

fib_lazy: fib_lazy.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<
fib_llazy: fib_llazy.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

fprintlst2: fprintlst2.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

fprtuple: fprtuple.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

gfact: gfact.dats ; $(PATSCC) -o $@ $<

######

hello: hello.dats ; $(PATSCC) -o $@ $<

######

intecho: intecho.dats ; $(PATSCC) -o $@ $<

######

intrange: intrange.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

linenmbr: linenmbr.dats ; \
  $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $< myatslib.dats 

######

listfuns: listfuns.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

listpermute: listpermute.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

ordset: ordset.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

sieve_lazy: sieve_lazy.dats ; \
  $(PATSCC) -D_GNU_SOURCE -DATS_MEMALLOC_GCBDW -O2 -o $@ $< -lgc

sieve_llazy: sieve_llazy_dats.c ; \
  $(PATSCC) -cleanaft -D_GNU_SOURCE -DATS_MEMALLOC_LIBC -O2 -o $@ $<
sieve_llazy_dats.c: sieve_llazy.dats ; $(PATSCC) -ccats $<

######

staref: staref.dats ; $(PATSCC) -o $@ $<

######

strprefix: strprefix.dats ; $(PATSCC) -o $@ $<

######

tally: tally.dats ; $(PATSCC) -D_ATS_EXCEPTION_NONE -o $@ $<

######

cleanats:: ; $(RMF) *_?ats.c

###### end of [Makefile] ######

=== doc/EXAMPLE/MISC/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######

CCOPT=gcc -std=c99

######

ifeq ("$(PATSHOME)","")
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="$(PATSHOME)"
endif

######

PATSOPT=$(PATSHOMEQ)/bin/patsopt
PATSLIB=$(PATSHOMEQ)/ccomp/atslib/lib

######

all::

######

LNS=ln -s
RMF=rm -f

######
#
all:: arith_overflow
arith_overflow: arith_overflow.exe
arith_overflow.exe: arith_overflow_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
arith_overflow_dats.c: arith_overflow.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output arith_overflow_dats.c --dynamic arith_overflow.dats
clean:: ; $(RMF) arith_overflow_dats.o
clean:: ; $(RMF) arith_overflow_dats.c
cleanall:: ; $(RMF) arith_overflow arith_overflow.exe

all:: coinflip
coinflip: coinflip.exe
coinflip.exe: coinflip_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
coinflip_dats.c: coinflip.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output coinflip_dats.c --dynamic coinflip.dats
clean:: ; $(RMF) coinflip_dats.o
clean:: ; $(RMF) coinflip_dats.c
cleanall:: ; $(RMF) coinflip coinflip.exe

all:: ferryman
ferryman: ferryman.exe
ferryman.exe: ferryman_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
ferryman_dats.c: ferryman.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output ferryman_dats.c --dynamic ferryman.dats
clean:: ; $(RMF) ferryman_dats.o
clean:: ; $(RMF) ferryman_dats.c
cleanall:: ; $(RMF) ferryman ferryman.exe

all:: fibver_loop
fibver_loop: fibver_loop.exe
fibver_loop.exe: fibver_loop_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
fibver_loop_dats.c: fibver_loop.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fibver_loop_dats.c --dynamic fibver_loop.dats
clean:: ; $(RMF) fibver_loop_dats.o
clean:: ; $(RMF) fibver_loop_dats.c
cleanall:: ; $(RMF) fibver_loop fibver_loop.exe

all:: fibver_trec
fibver_trec: fibver_trec.exe
fibver_trec.exe: fibver_trec_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
fibver_trec_dats.c: fibver_trec.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fibver_trec_dats.c --dynamic fibver_trec.dats
clean:: ; $(RMF) fibver_trec_dats.o
clean:: ; $(RMF) fibver_trec_dats.c
cleanall:: ; $(RMF) fibver_trec fibver_trec.exe

all:: isqrt
isqrt: isqrt.exe
isqrt.exe: isqrt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
isqrt_dats.c: isqrt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output isqrt_dats.c --dynamic isqrt.dats
clean:: ; $(RMF) isqrt_dats.o
clean:: ; $(RMF) isqrt_dats.c
cleanall:: ; $(RMF) isqrt isqrt.exe

all:: matrixops
matrixops: matrixops.exe
matrixops.exe: matrixops_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
matrixops_dats.c: matrixops.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output matrixops_dats.c --dynamic matrixops.dats
clean:: ; $(RMF) matrixops_dats.o
clean:: ; $(RMF) matrixops_dats.c
cleanall:: ; $(RMF) matrixops matrixops.exe

#
all:: autodiff
autodiff: autodiff.exe
autodiff.exe: autodiff_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_GCBDW -O2 -o $@ $< -lm -lgc
autodiff_dats.c: autodiff.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output autodiff_dats.c --dynamic autodiff.dats
clean:: ; $(RMF) autodiff_dats.o
clean:: ; $(RMF) autodiff_dats.c
cleanall:: ; $(RMF) autodiff autodiff.exe

all:: fib_memo
fib_memo: fib_memo.exe
fib_memo.exe: fib_memo_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
fib_memo_dats.c: fib_memo.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fib_memo_dats.c --dynamic fib_memo.dats
clean:: ; $(RMF) fib_memo_dats.o
clean:: ; $(RMF) fib_memo_dats.c
cleanall:: ; $(RMF) fib_memo fib_memo.exe

all:: fourslot
fourslot: fourslot.exe
fourslot.exe: fourslot_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
fourslot_dats.c: fourslot.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output fourslot_dats.c --dynamic fourslot.dats
clean:: ; $(RMF) fourslot_dats.o
clean:: ; $(RMF) fourslot_dats.c
cleanall:: ; $(RMF) fourslot fourslot.exe

all:: hanoi
hanoi: hanoi.exe
hanoi.exe: hanoi_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
hanoi_dats.c: hanoi.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output hanoi_dats.c --dynamic hanoi.dats
clean:: ; $(RMF) hanoi_dats.o
clean:: ; $(RMF) hanoi_dats.c
cleanall:: ; $(RMF) hanoi hanoi.exe

all:: monad_list
monad_list: monad_list.exe
monad_list.exe: monad_list_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
monad_list_dats.c: monad_list.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output monad_list_dats.c --dynamic monad_list.dats
clean:: ; $(RMF) monad_list_dats.o
clean:: ; $(RMF) monad_list_dats.c
cleanall:: ; $(RMF) monad_list monad_list.exe

all:: monad_maybe
monad_maybe: monad_maybe.exe
monad_maybe.exe: monad_maybe_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
monad_maybe_dats.c: monad_maybe.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output monad_maybe_dats.c --dynamic monad_maybe.dats
clean:: ; $(RMF) monad_maybe_dats.o
clean:: ; $(RMF) monad_maybe_dats.c
cleanall:: ; $(RMF) monad_maybe monad_maybe.exe

all:: monad_state
monad_state: monad_state.exe
monad_state.exe: monad_state_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
monad_state_dats.c: monad_state.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output monad_state_dats.c --dynamic monad_state.dats
clean:: ; $(RMF) monad_state_dats.o
clean:: ; $(RMF) monad_state_dats.c
cleanall:: ; $(RMF) monad_state monad_state.exe

all:: morse_enum
morse_enum: morse_enum.exe
morse_enum.exe: morse_enum_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
morse_enum_dats.c: morse_enum.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output morse_enum_dats.c --dynamic morse_enum.dats
clean:: ; $(RMF) morse_enum_dats.o
clean:: ; $(RMF) morse_enum_dats.c
cleanall:: ; $(RMF) morse_enum morse_enum.exe

all:: mysendmailist
mysendmailist: mysendmailist.exe
mysendmailist.exe: mysendmailist_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
mysendmailist_dats.c: mysendmailist.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output mysendmailist_dats.c --dynamic mysendmailist.dats
clean:: ; $(RMF) mysendmailist_dats.o
clean:: ; $(RMF) mysendmailist_dats.c
cleanall:: ; $(RMF) mysendmailist mysendmailist.exe

all:: passwdgen
passwdgen: passwdgen.exe
passwdgen.exe: passwdgen_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
passwdgen_dats.c: passwdgen.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output passwdgen_dats.c --dynamic passwdgen.dats
clean:: ; $(RMF) passwdgen_dats.o
clean:: ; $(RMF) passwdgen_dats.c
cleanall:: ; $(RMF) passwdgen passwdgen.exe

all:: queens_lazy
queens_lazy: queens_lazy.exe
queens_lazy.exe: queens_lazy_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
queens_lazy_dats.c: queens_lazy.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output queens_lazy_dats.c --dynamic queens_lazy.dats
clean:: ; $(RMF) queens_lazy_dats.o
clean:: ; $(RMF) queens_lazy_dats.c
cleanall:: ; $(RMF) queens_lazy queens_lazy.exe

all:: queens_loop
queens_loop: queens_loop.exe
queens_loop.exe: queens_loop_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
queens_loop_dats.c: queens_loop.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output queens_loop_dats.c --dynamic queens_loop.dats
clean:: ; $(RMF) queens_loop_dats.o
clean:: ; $(RMF) queens_loop_dats.c
cleanall:: ; $(RMF) queens_loop queens_loop.exe

all:: randerlin
randerlin: randerlin.exe
randerlin.exe: randerlin_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
randerlin_dats.c: randerlin.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output randerlin_dats.c --dynamic randerlin.dats
clean:: ; $(RMF) randerlin_dats.o
clean:: ; $(RMF) randerlin_dats.c
cleanall:: ; $(RMF) randerlin randerlin.exe

all:: readdirall
readdirall: readdirall.exe
readdirall.exe: readdirall_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
readdirall_dats.c: readdirall.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output readdirall_dats.c --dynamic readdirall.dats
clean:: ; $(RMF) readdirall_dats.o
clean:: ; $(RMF) readdirall_dats.c
cleanall:: ; $(RMF) readdirall readdirall.exe

all:: sieve
sieve: sieve.exe
sieve.exe: sieve_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
sieve_dats.c: sieve.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output sieve_dats.c --dynamic sieve.dats
clean:: ; $(RMF) sieve_dats.o
clean:: ; $(RMF) sieve_dats.c
cleanall:: ; $(RMF) sieve sieve.exe

all:: sllist_mapfree
sllist_mapfree: sllist_mapfree.exe
sllist_mapfree.exe: sllist_mapfree_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
sllist_mapfree_dats.c: sllist_mapfree.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output sllist_mapfree_dats.c --dynamic sllist_mapfree.dats
clean:: ; $(RMF) sllist_mapfree_dats.o
clean:: ; $(RMF) sllist_mapfree_dats.c
cleanall:: ; $(RMF) sllist_mapfree sllist_mapfree.exe

all:: stdlib_bsearch
stdlib_bsearch: stdlib_bsearch.exe
stdlib_bsearch.exe: stdlib_bsearch_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
stdlib_bsearch_dats.c: stdlib_bsearch.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output stdlib_bsearch_dats.c --dynamic stdlib_bsearch.dats
clean:: ; $(RMF) stdlib_bsearch_dats.o
clean:: ; $(RMF) stdlib_bsearch_dats.c
cleanall:: ; $(RMF) stdlib_bsearch stdlib_bsearch.exe

all:: strmat
strmat: strmat.exe
strmat.exe: strmat_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
strmat_dats.c: strmat.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output strmat_dats.c --dynamic strmat.dats
clean:: ; $(RMF) strmat_dats.o
clean:: ; $(RMF) strmat_dats.c
cleanall:: ; $(RMF) strmat strmat.exe

all:: wclines
wclines: wclines.exe
wclines.exe: wclines_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
wclines_dats.c: wclines.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output wclines_dats.c --dynamic wclines.dats
clean:: ; $(RMF) wclines_dats.o
clean:: ; $(RMF) wclines_dats.c
cleanall:: ; $(RMF) wclines wclines.exe

all:: word-chain
word-chain: word-chain.exe
word-chain.exe: word-chain_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
word-chain_dats.c: word-chain.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output word-chain_dats.c --dynamic word-chain.dats
clean:: ; $(RMF) word-chain_dats.o
clean:: ; $(RMF) word-chain_dats.c
cleanall:: ; $(RMF) word-chain word-chain.exe

#
######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o *_?ats.c
clean:: ; $(RMF) *_atxt.txt
clean:: ; $(RMF) *_atxt.dats
clean:: ; $(RMF) Makefile.exe

=== doc/EXAMPLE/PCPV/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######

PATSHOMEQ="$(PATSHOME)"
PATSOPT=$(PATSHOMEQ)/bin/patsopt

######

all::

######

all:: bsearch_arr
bsearch_arr: bsearch_arr.dats ; $(PATSOPT) --typecheck --dynamic bsearch_arr.dats

######

all:: quicksort_lst
quicksort_lst: quicksort_lst.dats ; $(PATSOPT) --typecheck --dynamic quicksort_lst.dats

######

LNS=ln -s
RMF=rm -f

######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o *_?ats.c
clean:: ; $(RMF) *_atxt.txt
clean:: ; $(RMF) *_atxt.dats

cleanall:: clean

###### end of [Makefile] ######

=== debian/changelog ===
ats2-lang (0.2.6-2) unstable; urgency=medium

  * Remove extraneous flycheck-ats2 mode. (Closes: #814497) 

 -- Matthew Danish <mrd@debian.org>  Fri, 12 Feb 2016 16:12:49 +0000

ats2-lang (0.2.6-1) unstable; urgency=medium

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Thu, 11 Feb 2016 15:36:13 +0000

ats2-lang (0.2.4-1) unstable; urgency=medium

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Fri, 30 Oct 2015 13:36:46 +0000

ats2-lang (0.2.3-1) unstable; urgency=medium

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Mon, 28 Sep 2015 13:16:32 +0100

ats2-lang (0.2.2-1) unstable; urgency=medium

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Mon, 14 Sep 2015 17:46:45 +0100

=== debian/control ===
Source: ats2-lang
Section: devel
Priority: optional
Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, libgmp-dev
Standards-Version: 3.9.6
Homepage: http://www.ats-lang.org/

Package: ats2-lang
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgc-dev, emacsen-common (>= 2.0.8)
Description: ATS version 2 programming language compiler
 ATS2 a.k.a. ATS/Postiats is a programming language with a highly expressive
 type system rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Postiats) is written in ATS (ATS/Anairiats) itself.
 It can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler patsopt and the frontend patscc, as well as
 the emacs mode for the language.
